import rp from "request-promise-native";
import url from "url";

const apis = {
  reverse: "https://pr0.totally.rip/api/v2/item?file=",
  pr0gag: {
    list: "https://pr0gramm.com/api/items/get/?flags=15&id=",
    item: "https://pr0gramm.com/api/items/info?flags=15&itemId="
  }
};
const flags = {
  1: "sfw",
  2: "nsfw",
  4: "nsfl",
  8: "nsfp"
};
const regex = /(img|vid)\.pr0gramm\.com\/((?:\d+){4}\/(?:\d+){2}\/(?:\d+){2}\/(?:\w{0,20})\.(?:webm|png|jpg|mp4|webm)?)/gi;
const site = "https://pr0gramm.com/new/";

export default bot => {
  bot._trigger.set("pr0gag", new bot.trigger({
    call: /(vid|img)\.pr0gramm\.com.*/i,
    set: "uwe",
    f: e => {
      const link = "https://"+e.message.match(regex)[0];
      const tmp = url.parse(link).path.substr(1);
      rp(apis.reverse + tmp)
        .then(res => {
          if(res.error)
            throw res.error;
          return JSON.parse(res).data.id;
        })
        .then(id => Promise.all([
          rp(apis.pr0gag.list + id.toString()),
          rp(apis.pr0gag.item + id.toString()),
          id
        ]).then(([list, item, id]) => [
            JSON.parse(list).items.filter(item => item.id === id)[0],
            JSON.parse(item),
            id
          ])
          .then(([list, item, id]) => ({
            created: list.created,
            up: list.up,
            down: list.down,
            score: list.up - list.down,
            ratio: (list.up / (list.up + list.down)).toFixed(2),
            flags: flags[list.flags],
            user: list.user,
            comments: item.comments.length,
            toptags: item.tags.splice(0, 3).map(tag => tag.tag),
            link: site + id.toString()
          }))
          .then(meta => [
            `c: ${meta.created}`,
            `u: ${meta.up}`,
            `d: ${meta.down}`,
            `s: ${meta.score}`,
            `r: ${meta.ratio}`,
            `f: ${meta.flags}`,
            `u: ${meta.user}`,
            `co: ${meta.comments}`,
            `t: ${meta.toptags}`,
            `l: ${meta.link}`
          ].join("; "))
          .then(out => e.reply(out))
        ).catch(err => e.reply(err));
    }
  }));
};
